All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Pages
CustomCompoundBondForce Class Reference

This class supports a wide variety of bonded interactions. More...

`#include <CustomCompoundBondForce.h>`

Inheritance diagram for CustomCompoundBondForce:

## Public Member Functions

| CustomCompoundBondForce (int numParticles, const std::string &energy)
| Create a CustomCompoundBondForce. More...
| ~CustomCompoundBondForce ()
int | getNumParticlesPerBond () const
| Get the number of particles used to define each bond. More...
int | getNumBonds () const
| Get the number of bonds for which force field parameters have been defined. More...
int | getNumPerBondParameters () const
| Get the number of per-bond parameters that the interaction depends on. More...
int | getNumGlobalParameters () const
| Get the number of global parameters that the interaction depends on. More...
int | getNumTabulatedFunctions () const
| Get the number of tabulated functions that have been defined. More...
int | getNumFunctions () const
| Get the number of tabulated functions that have been defined. More...
const std::string & | getEnergyFunction () const
| Get the algebraic expression that gives the interaction energy of each bond. More...
void | setEnergyFunction (const std::string &energy)
| Set the algebraic expression that gives the interaction energy of each bond. More...
int | addPerBondParameter (const std::string &name)
| Add a new per-bond parameter that the interaction may depend on. More...
const std::string & | getPerBondParameterName (int index) const
| Get the name of a per-bond parameter. More...
void | setPerBondParameterName (int index, const std::string &name)
| Set the name of a per-bond parameter. More...
int | addGlobalParameter (const std::string &name, double defaultValue)
| Add a new global parameter that the interaction may depend on. More...
const std::string & | getGlobalParameterName (int index) const
| Get the name of a global parameter. More...
void | setGlobalParameterName (int index, const std::string &name)
| Set the name of a global parameter. More...
double | getGlobalParameterDefaultValue (int index) const
| Get the default value of a global parameter. More...
void | setGlobalParameterDefaultValue (int index, double defaultValue)
| Set the default value of a global parameter. More...
int | addBond (const std::vector< int > &particles, const std::vector< double > &parameters)
| Add a bond to the force. More...
void | getBondParameters (int index, std::vector< int > &particles, std::vector< double > &parameters) const
| Get the properties of a bond. More...
void | setBondParameters (int index, const std::vector< int > &particles, const std::vector< double > &parameters)
| Set the properties of a bond. More...
int | addTabulatedFunction (const std::string &name, TabulatedFunction *function)
| Add a tabulated function that may appear in the energy expression. More...
const TabulatedFunction & | getTabulatedFunction (int index) const
| Get a const reference to a tabulated function that may appear in the energy expression. More...
TabulatedFunction & | getTabulatedFunction (int index)
| Get a reference to a tabulated function that may appear in the energy expression. More...
const std::string & | getTabulatedFunctionName (int index) const
| Get the name of a tabulated function that may appear in the energy expression. More...
int | addFunction (const std::string &name, const std::vector< double > &values, double min, double max)
| Add a tabulated function that may appear in the energy expression. More...
void | getFunctionParameters (int index, std::string &name, std::vector< double > &values, double &min, double &max) const
| Get the parameters for a tabulated function that may appear in the energy expression. More...
void | setFunctionParameters (int index, const std::string &name, const std::vector< double > &values, double min, double max)
| Set the parameters for a tabulated function that may appear in the energy expression. More...
void | updateParametersInContext (Context &context)
| Update the per-bond parameters in a Context to match those stored in this Force object. More...
bool | usesPeriodicBoundaryConditions () const
| Returns whether or not this force makes use of periodic boundary conditions. More...
Public Member Functions inherited from Force
| Force ()
virtual | ~Force ()
int | getForceGroup () const
| Get the force group this Force belongs to. More...
void | setForceGroup (int group)
| Set the force group this Force belongs to. More...

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System. More...
Protected Member Functions inherited from Force
ForceImpl & | getImplInContext (Context &context)
| Get the ForceImpl corresponding to this Force in a Context. More...
ContextImpl & | getContextImpl (Context &context)
| Get the ContextImpl corresponding to a Context. More...

## Detailed Description

This class supports a wide variety of bonded interactions.

It defines a "bond" as a single energy term that depends on the positions of a fixed set of particles. The number of particles involved in a bond, and how the energy depends on their positions, is configurable. It may depend on the positions of individual particles, the distances between pairs of particles, the angles formed by sets of three particles, and the dihedral angles formed by sets of four particles.

We refer to the particles in a bond as p1, p2, p3, etc. For each bond, CustomCompoundBondForce evaluates a user supplied algebraic expression to determine the interaction energy. The expression may depend on the following variables and functions:

- x1, y1, z1, x2, y2, z2, etc.: The x, y, and z coordinates of the particle positions. For example, x1 is the x coordinate of particle p1, and y3 is the y coordinate of particle p3.
- distance(p1, p2): the distance between particles p1 and p2 (where "p1" and "p2" may be replaced by the names of whichever particles you want to calculate the distance between).
- angle(p1, p2, p3): the angle formed by the three specified particles.
- dihedral(p1, p2, p3, p4): the dihedral angle formed by the four specified particles.

The expression also may involve tabulated functions, and may depend on arbitrary global and per-bond parameters.

To use this class, create a CustomCompoundBondForce object, passing an algebraic expression to the constructor that defines the interaction energy of each bond. Then call addPerBondParameter() to define per-bond parameters and addGlobalParameter() to define global parameters. The values of per-bond parameters are specified as part of the system definition, while values of global parameters may be modified during a simulation by calling Context::setParameter().

Next, call addBond() to define bonds and specify their parameter values. After a bond has been added, you can modify its parameters by calling setBondParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

As an example, the following code creates a CustomCompoundBondForce that implements a Urey-Bradley potential. This is an interaction between three particles that depends on the angle formed by p1-p2-p3, and on the distance between p1 and p3.

`CustomCompoundBondForce* force = new CustomCompoundBondForce(3, "0.5*(kangle*(angle(p1,p2,p3)-theta0)^2+kbond*(distance(p1,p3)-r0)^2)");`

This force depends on four parameters: kangle, kbond, theta0, and r0. The following code defines these as per-bond parameters:

``

    force->addPerBondParameter("kangle");
    force->addPerBondParameter("kbond");
    force->addPerBondParameter("theta0");
    force->addPerBondParameter("r0");

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, floor, ceil, step, delta, select. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise. select(x,y,z) = z if x = 0, y otherwise.

In addition, you can call addTabulatedFunction() to define a new function based on tabulated values. You specify the function by creating a TabulatedFunction object. That function can then appear in the expression.

## Constructor & Destructor Documentation

CustomCompoundBondForce | ( | int | numParticles,
|  | const std::string & | energy
| ) |  |

explicit

Create a CustomCompoundBondForce.

Parameters

  numParticles | the number of particles used to define each bond
  energy | an algebraic expression giving the interaction energy of each bond as a function of particle positions, inter-particle distances, angles, and dihedrals, and any global and per-bond parameters

~CustomCompoundBondForce | ( |  | ) |

## Member Function Documentation

int addBond | ( | const std::vector< int > & | particles,
|  | const std::vector< double > & | parameters
| ) |  |

Add a bond to the force.

Parameters

  particles | the indices of the particles the bond depends on
  parameters | the list of per-bond parameter values for the new bond

Returns
  the index of the bond that was added

int addFunction | ( | const std::string & | name,
|  | const std::vector< double > & | values,
|  | double | min,
|  | double | max
| ) |  |

Add a tabulated function that may appear in the energy expression.

Deprecated:
  This method exists only for backward compatibility. Use addTabulatedFunction() instead.

int addGlobalParameter | ( | const std::string & | name,
|  | double | defaultValue
| ) |  |

Add a new global parameter that the interaction may depend on.

Parameters

  name | the name of the parameter
  defaultValue | the default value of the parameter

Returns
  the index of the parameter that was added

int addPerBondParameter | ( | const std::string & | name | ) |

Add a new per-bond parameter that the interaction may depend on.

Parameters

  name | the name of the parameter

Returns
  the index of the parameter that was added

int addTabulatedFunction | ( | const std::string & | name,
|  | TabulatedFunction * | function
| ) |  |

Add a tabulated function that may appear in the energy expression.

Parameters

  name | the name of the function as it appears in expressions
  function | a TabulatedFunction object defining the function. The TabulatedFunction should have been created on the heap with the "new" operator. The Force takes over ownership of it, and deletes it when the Force itself is deleted.

Returns
  the index of the function that was added

ForceImpl* createImpl | ( |  | ) | const

protectedvirtual

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

void getBondParameters | ( | int | index,
|  | std::vector< int > & | particles,
|  | std::vector< double > & | parameters
| ) |  | const

Get the properties of a bond.

Parameters

  index | the index of the bond to get
  particles | the indices of the particles in the bond
  parameters | the list of per-bond parameter values for the bond

const std::string& getEnergyFunction | ( |  | ) | const

Get the algebraic expression that gives the interaction energy of each bond.

void getFunctionParameters | ( | int | index,
|  | std::string & | name,
|  | std::vector< double > & | values,
|  | double & | min,
|  | double & | max
| ) |  | const

Get the parameters for a tabulated function that may appear in the energy expression.

Deprecated:
  This method exists only for backward compatibility. Use getTabulatedFunctionParameters() instead. If the specified function is not a Continuous1DFunction, this throws an exception.

double getGlobalParameterDefaultValue | ( | int | index | ) | const

Get the default value of a global parameter.

Parameters

  index | the index of the parameter for which to get the default value

Returns
  the parameter default value

const std::string& getGlobalParameterName | ( | int | index | ) | const

Get the name of a global parameter.

Parameters

  index | the index of the parameter for which to get the name

Returns
  the parameter name

int getNumBonds | ( |  | ) | const

inline

Get the number of bonds for which force field parameters have been defined.

int getNumFunctions | ( |  | ) | const

inline

Get the number of tabulated functions that have been defined.

Deprecated:
  This method exists only for backward compatibility. Use getNumTabulatedFunctions() instead.

int getNumGlobalParameters | ( |  | ) | const

inline

Get the number of global parameters that the interaction depends on.

int getNumParticlesPerBond | ( |  | ) | const

inline

Get the number of particles used to define each bond.

int getNumPerBondParameters | ( |  | ) | const

inline

Get the number of per-bond parameters that the interaction depends on.

int getNumTabulatedFunctions | ( |  | ) | const

inline

Get the number of tabulated functions that have been defined.

const std::string& getPerBondParameterName | ( | int | index | ) | const

Get the name of a per-bond parameter.

Parameters

  index | the index of the parameter for which to get the name

Returns
  the parameter name

const TabulatedFunction& getTabulatedFunction | ( | int | index | ) | const

Get a const reference to a tabulated function that may appear in the energy expression.

Parameters

  index | the index of the function to get

Returns
  the TabulatedFunction object defining the function

TabulatedFunction& getTabulatedFunction | ( | int | index | ) |

Get a reference to a tabulated function that may appear in the energy expression.

Parameters

  index | the index of the function to get

Returns
  the TabulatedFunction object defining the function

const std::string& getTabulatedFunctionName | ( | int | index | ) | const

Get the name of a tabulated function that may appear in the energy expression.

Parameters

  index | the index of the function to get

Returns
  the name of the function as it appears in expressions

void setBondParameters | ( | int | index,
|  | const std::vector< int > & | particles,
|  | const std::vector< double > & | parameters
| ) |  |

Set the properties of a bond.

Parameters

  index | the index of the bond group to set
  particles | the indices of the particles in the bond
  parameters | the list of per-bond parameter values for the bond

void setEnergyFunction | ( | const std::string & | energy | ) |

Set the algebraic expression that gives the interaction energy of each bond.

void setFunctionParameters | ( | int | index,
|  | const std::string & | name,
|  | const std::vector< double > & | values,
|  | double | min,
|  | double | max
| ) |  |

Set the parameters for a tabulated function that may appear in the energy expression.

Deprecated:
  This method exists only for backward compatibility. Use setTabulatedFunctionParameters() instead. If the specified function is not a Continuous1DFunction, this throws an exception.

void setGlobalParameterDefaultValue | ( | int | index,
|  | double | defaultValue
| ) |  |

Set the default value of a global parameter.

Parameters

  index | the index of the parameter for which to set the default value
  name | the default value of the parameter

void setGlobalParameterName | ( | int | index,
|  | const std::string & | name
| ) |  |

Set the name of a global parameter.

Parameters

  index | the index of the parameter for which to set the name
  name | the name of the parameter

void setPerBondParameterName | ( | int | index,
|  | const std::string & | name
| ) |  |

Set the name of a per-bond parameter.

Parameters

  index | the index of the parameter for which to set the name
  name | the name of the parameter

void updateParametersInContext | ( | Context & | context | ) |

Update the per-bond parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setBondParameters() to modify this object's parameters, then call updateParametersInContext() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-bond parameters. All other aspects of the Force (such as the energy function) are unaffected and can only be changed by reinitializing the Context. The set of particles involved in a bond cannot be changed, nor can new bonds be added.

bool usesPeriodicBoundaryConditions | ( |  | ) | const

inlinevirtual

Returns whether or not this force makes use of periodic boundary conditions.

Returns
  false

Reimplemented from Force.

The documentation for this class was generated from the following file:

- CustomCompoundBondForce.h